/*
This is a game demo written by Wingo Sai-Keung Wong.
OGRE is employed for graphics rendering.
CEGUI is employed for GUI.
Date: Dec 2006 - Jan 2007
Email: wingo.wong@gmail.com
*/
#ifndef __MY_MESH_H__
#define __MY_MESH_H__
#include "Ogre.h"
#include "common.h"
using namespace Ogre;

class MyMesh {
private:
	MeshPtr mMesh;
	SceneManager *mSceneMgr;
	SceneNode *mNode;
	Entity *mEntity;
	//
	Real w, h;
	HardwareVertexBufferSharedPtr posnormVertexBuffer;
	HardwareIndexBufferSharedPtr indexBuffer;
	HardwareVertexBufferSharedPtr* texcoordsVertexBuffers;
private:
	//
	void buildMesh(HardwareVertexBufferSharedPtr posnormVertexBuffer);
public:
	MyMesh(SceneManager *m);
	void createMesh(const String &matName);
};

#endif