/*
This is a game demo written by Wingo Sai-Keung Wong.
OGRE is employed for graphics rendering.
CEGUI is employed for GUI.
Date: Dec 2006 - Jan 2007
Email: wingo.wong@gmail.com
*/
#include "common.h"
#include "Ogre.h"
using namespace Ogre;

namespace ns_Common {
	Root *ms_Root = NULL;
	SceneManager *ms_SceneMgr = NULL;
	SceneNode *ms_CameraNode = NULL;
	Camera *ms_Camera = NULL;
	RenderWindow* ms_Window;
};

void initSceneManagerAndCamera(Root *r, RenderWindow *w, SceneManager *m, Camera *camera, SceneNode *cameraNode)
{
	using namespace ns_Common;
	ms_Root = r;
	ms_Window = w;
	ms_SceneMgr = m;
	ms_Camera = camera;
	ms_CameraNode = cameraNode;
}

inline void genNameUsingIndex(const String & prefix, int index, String &out_name)
{
	out_name= prefix + StringConverter::toString(static_cast<int>(index));
}